package examples;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import libHamCast.HamcastUtility;
import libHamCast.MulticastSocket;
import multicastApi.GroupSet;
import multicastApi.NetworkMInterface;

public class SomeSocketAndUtilityFunctions {

	public static void main(String[] args) {
		try {
			MulticastSocket sender1=new MulticastSocket();


			/*Test Interface-Actions: */



			List<NetworkMInterface> IfacesS1=sender1.getInterfaces();
			List<Long> IfaceIdS1=sender1.getSockInterfaceIDs();
			System.out.println("Sender1-Interfaces:");


			//ADDING ONE INTERFACE
			for(NetworkMInterface nmi:IfacesS1){
				System.out.println("\t"+nmi);
				assert(IfaceIdS1.contains(Long.valueOf(nmi.getIndex())));
			}
			assert(IfaceIdS1.size()==IfacesS1.size());


			NetworkMInterface newNMI=new NetworkMInterface(2, "lo", "localhost","loopback");

			System.out.println("\nadding Interface: "+newNMI+
					"\n\tsuccess:"+sender1.addInterface(newNMI.getIndex())+"\n");


			IfacesS1=sender1.getInterfaces();
			IfaceIdS1=sender1.getSockInterfaceIDs();
			System.out.println("Sender1-Interfaces:");

			for(NetworkMInterface nmi:IfacesS1){
				System.out.println("\t"+nmi);
				assert(IfaceIdS1.contains(Long.valueOf(nmi.getIndex())));
			}
			assert(IfaceIdS1.size()==IfacesS1.size());



			//DELETING ONE INTERFACE
			NetworkMInterface delIface=IfacesS1.get(1);

			System.out.println("\ndeleting Interface: "+delIface+
					"\n\tsuccess:"+sender1.delInterface(newNMI.getIndex())+"\n");

			IfacesS1=sender1.getInterfaces();
			IfaceIdS1=sender1.getSockInterfaceIDs();
			System.out.println("Sender1-Interfaces:");

			for(NetworkMInterface nmi:IfacesS1){
				System.out.println("\t"+nmi);
				assert(IfaceIdS1.contains(Long.valueOf(nmi.getIndex())));
			}
			assert(IfaceIdS1.size()==IfacesS1.size());


			//SETTING TO ONLY LOCALHOST INTERFACE
			List<Integer> toSet=new ArrayList<Integer>();
			List<NetworkMInterface> allInterface=HamcastUtility.getAllInterfaces();
			for(NetworkMInterface nmi: allInterface){
				if(nmi.getDisplayName().startsWith("loopback")){
					toSet.add(nmi.getIndex());
				}
			}


			System.out.println("\nsetting Interface: "+Arrays.toString(toSet.toArray())+
					"\n\tsuccess:"+sender1.setInterfaces(toSet)+"\n");

			IfacesS1=sender1.getInterfaces();
			IfaceIdS1=sender1.getSockInterfaceIDs();
			System.out.println("Sender1-Interfaces:");

			for(NetworkMInterface nmi:IfacesS1){
				System.out.println("\t"+nmi);
				assert(IfaceIdS1.contains(Long.valueOf(nmi.getIndex())));
			}
			assert(IfaceIdS1.size()==IfacesS1.size());



			//Sending in several groups.
			sender1=new MulticastSocket();
			MulticastSocket receiver1=new MulticastSocket();
			URI uri = new URI("ip://239.0.0.1:1234");
			receiver1.join(uri);
			receiver1.join("ip://239:0.0.1:1235");
			
			//if you want to receive this messages. join this groups before sending with another programm.
			
			  for(int j=0;j<23;j++){
				for(int i=1234; i<1244;i++){
					sender1.send("ip://239.0.0.1:"+String.valueOf(i), ("from: "+i+"Hello World"+String.valueOf(j)).getBytes());
				}
			}
			
			
		//HamcastUtility-Functions
		System.out.println("\n\n------------HamcastUtility - Functions------------\n");
		System.out.println("designated Host: "+HamcastUtility.designatedHost(receiver1.getInterfaces().get(0), "ip://239.0.0.1:1234"));
		System.out.println("parents: "+HamcastUtility.parentSet(receiver1.getInterfaces().get(0), "ip://239.0.0.1:1234"));
		System.out.println("children: "+Arrays.toString(HamcastUtility.childrenSet(receiver1.getInterfaces().get(0), "ip://239.0.0.1:1234").toArray()));

		System.out.println("all Interfaces:");
		List<NetworkMInterface> allInterfaces=HamcastUtility.getAllInterfaces();
		for(NetworkMInterface nmi: allInterfaces){
			System.out.println("\t"+nmi);
		}
		
		System.out.println("\nactive registered multicast adresses (groupSet):");
		List<GroupSet> groups=HamcastUtility.groupSet(receiver1.getInterfaces().get(0));
		for(GroupSet g: groups){
			System.out.println("\t"+g);
		}
		
		System.out.println("\nneigborSet():");
		List<URI> neighbours = HamcastUtility.neighborSet(receiver1.getInterfaces().get(0));
		for(URI u: neighbours){
			System.out.println("\t"+u);
		}
		
		
		//changing the default exception handler
		HamcastUtility.setExceptionHandler(new Runnable() {
			
			@Override
			public void run() {
				System.out.println("your exception handling as you like it.");
				
			}
			@Override
			public String toString(){
				return "your handler";
			}
		});
		
		System.out.println("Exceptionhandler: "+HamcastUtility.getExceptionHandler());
		
		
		System.out.println();
		
		} catch (Exception e) {

			e.printStackTrace();
		}

	}

}
